﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Data.SqlClient;

namespace employeesapp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        


            
        
        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'employeesDataSet.Employee' table. You can move, or remove it, as needed.
           // this.employeeTableAdapter.Fill(this.employeesDataSet.Employee);

            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Users\\Bisan\\Documents\\Visual Studio 2010\\Projects\\employeesapp\\employeesapp\\employees.mdb");
            OleDbDataAdapter ad = new OleDbDataAdapter("select * from employee ", conn);

            DataSet ds = new DataSet();
            ad.Fill(ds, "employee");
            BindingSource bs = new BindingSource();
            bs.DataSource = ds.Tables["employee"];


            idtext.DataBindings.Add("text", bs, "EmpID");
            nametext.DataBindings.Add("text", bs, "Name");
            jobtext.DataBindings.Add("text", bs, "Jobtitle");
            comtext.DataBindings.Add("text", bs, "company");


            idtext.Enabled = false;

        }

        private void newb_Click(object sender, EventArgs e)
        {
            idtext.Enabled = false;

            
            nametext.Enabled = true;
            jobtext.Enabled = true;
            comtext.Enabled = true;

                int i;
                   if (int.TryParse(idtext.Text, out i))
                     {
                       idtext.Text = (i + 1).ToString("D4");
                     } 


            nametext.Clear();
            jobtext.Clear();
            comtext.Clear();


            /* employee emp = new employee();
             DataSet ds = emp.get();
             DGV1.DataSource = ds.Tables[0];*/


        }

        private void addb_Click(object sender, EventArgs e)
        {
            if (nametext.Text.Equals("") || jobtext.Text.Equals("") || comtext.Text.Equals(""))
            {
                MessageBox.Show("All required data is not entered by you.", " Employees App", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            employee emp1 = new employee();
            //emp1.EmpID = idtext.Text;
            emp1.Name = nametext.Text;
            emp1.Jobtitle = jobtext.Text;
            emp1.Company = comtext.Text;

            emp1.AddNew();
            MessageBox.Show("New Employee Successfully added");
                       

            nametext.Clear();
            jobtext.Clear();
            comtext.Clear();
            //idtext.Clear();
            nametext.Focus();

            idtext.Enabled = false;
            nametext.Enabled = false;
            jobtext.Enabled = false;
            comtext.Enabled = false;

            employee emp = new employee();
            DataSet ds = emp.get();
            DGV1.DataSource = ds.Tables[0];

        }

        private void searchb_Click(object sender, EventArgs e)
        {
            OleDbConnection con;
            OleDbDataAdapter ad;
            //text test
            if (searchtext.Text == "")
            {
                MessageBox.Show("Plese Inter Employee's ID you are searching for");
            }
            else
            {

                con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\\employees.mdb");
                ad = new OleDbDataAdapter("SELECT * FROM employee WHERE EmpID='searchtext.text'", con);
                ad.SelectCommand.Parameters.Add("@EmpID", OleDbType.Integer);
                ad.SelectCommand.Parameters["@EmpID"].Value = int.Parse(searchtext.Text);


                DataSet ds = new DataSet();
                ad.Fill(ds, "DGV1");
                DGV1.DataSource = ds.Tables["DGV1"];
                DGV1.Refresh();
                DGV1.Update();

            }
        }

        private void exitb_Click(object sender, EventArgs e)
        {
            //ask user before quit


            DialogResult dr = MessageBox.Show("Are you sure you want to quit ?", "Confirm", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation);
            if (dr == DialogResult.Yes)
                Application.Exit();

        }

        private void editb_Click(object sender, EventArgs e)
        {


        }

        private void deleteb_Click(object sender, EventArgs e)
        {
            employee emp1 = new employee();
            emp1.Name = nametext.Text;
            emp1.Jobtitle = jobtext.Text;
            emp1.Company = comtext.Text;

            emp1.Delete();
            MessageBox.Show("The Employee have been Successfully deleted from the data base");

            nametext.Clear();
            jobtext.Clear();
            comtext.Clear();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (nametext.Text.Equals("") || jobtext.Text.Equals("") || comtext.Text.Equals(""))
            {
                MessageBox.Show("All required data is not entered by you.", " Employees App", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            employee emp1 = new employee();
            emp1.Name = nametext.Text;
            emp1.Jobtitle = jobtext.Text;
            emp1.Company = comtext.Text;

            emp1.Update();
            MessageBox.Show("Employee data have been Successfully updated");

            nametext.Clear();
            jobtext.Clear();
            comtext.Clear();
            //idtext.Clear();
        }

        private void DGV1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            //it checks if the row index of the cell is greater than or equal to zero
            if (e.RowIndex >= 0)
            {
                //gets a collection that contains all the rows
                DataGridViewRow row = this.DGV1.Rows[e.RowIndex];
                //populate the textbox from specific value of the coordinates of column and row.
                idtext.Text = row.Cells[0].Value.ToString();
                nametext.Text = row.Cells[1].Value.ToString();
                jobtext.Text = row.Cells[2].Value.ToString();
                comtext.Text = row.Cells[3].Value.ToString();


            } 
        }

        private void DGV1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            
        }
        private void button1_Click_1(object sender, EventArgs e)
        {
            employee emp = new employee();
            DataSet ds = emp.get();
            DGV1.DataSource = ds.Tables[0];
            
        }

        private void nametext_TextChanged(object sender, EventArgs e)
        {

            if (!System.Text.RegularExpressions.Regex.IsMatch(nametext.Text, "^[a-zA-Z]"))
            {
            // MessageBox.Show("This textbox accepts only alphabetical characters");
             //nametext.Text.Remove(nametext.Text.Length - 1);
             nametext.Clear();

            }
        }

        private void jobtext_TextChanged(object sender, EventArgs e)
        {
            if (!System.Text.RegularExpressions.Regex.IsMatch(jobtext.Text, "^[a-zA-Z]"))
            {
                //MessageBox.Show("This textbox accepts only alphabetical characters");
                jobtext.Clear();
            }
        }

        private void comtext_TextChanged(object sender, EventArgs e)
        {
            if (!System.Text.RegularExpressions.Regex.IsMatch(comtext.Text, "^[a-zA-Z]"))
            {
                //MessageBox.Show("This textbox accepts only alphabetical characters");
                comtext.Clear();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }
        
    }
}
